﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace Vol3ASPsamples
{
    public partial class GanttSamples : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var resource = GanttDefaultData.ResourceDataContext.GetResourceData();
            var DataSource = GanttDefaultData.GetTaskData();
            this.Gantt.DataSource = DataSource;
            this.Gantt.DataBind();
            this.Gantt.Resources = resource; 
        }
        public class GanttDefaultData
        {

            public class TaskDetails
            {
                public int TaskID { get; set; }
                public string TaskName { get; set; }
                public string StartDate { get; set; }
                public string EndDate { get; set; }
                public int Duration { get; set; }
                public string Progress { get; set; }
                public List<TaskDetails> SubTasks { get; set; }
                public List<object> ResourceID { get; set; }
                public string Predecessors { get; set; }
            }

            public static List<TaskDetails> GetTaskData()
            {
                List<TaskDetails> tasks = new List<TaskDetails>();

                tasks.Add(new TaskDetails()
                {
                    TaskID = 1,
                    TaskName = "Project Schedule",
                    StartDate = "02/03/2014",
                    EndDate = "03/07/2014"
                });

                tasks[0].SubTasks = new List<TaskDetails>();

                tasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 2,
                    TaskName = "Planning",
                    StartDate = "02/03/2014",
                    EndDate = "02/07/2014"
                });

                tasks[0].SubTasks[0].SubTasks = new List<TaskDetails>();


                tasks[0].SubTasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 3,
                    TaskName = "Plan timeline",
                    StartDate = "02/03/2014",
                    EndDate = "02/07/2014",
                    Duration = 5,
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 4,
                    TaskName = "Plan budget",
                    StartDate = "02/03/2014",
                    EndDate = "02/07/2014",
                    Duration = 5,
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 5,
                    TaskName = "Allocate resources",
                    StartDate = "02/03/2014",
                    EndDate = "02/07/2014",
                    Duration = 5,
                    Progress = "100",
                    ResourceID = new List<object>() { 1 }
                });
                tasks[0].SubTasks[0].SubTasks.Add(new TaskDetails()
                {
                    TaskID = 6,
                    TaskName = "Planning complete",
                    StartDate = "02/07/2014",
                    EndDate = "02/07/2014",
                    Duration = 0,
                    Predecessors = "3FS,4FS,5FS"
                });


                return tasks;

            }


            public class ResourceDataContext
            {
                public class Resources
                {
                    public int ResourceID { get; set; }
                    public string ResourceName { get; set; }
                }

                public static List<Resources> GetResourceData()
                {
                    List<Resources> resourceDetails = new List<Resources>();

                    resourceDetails.Add(new Resources() { ResourceID = 1, ResourceName = "Project Manager" });
                    resourceDetails.Add(new Resources() { ResourceID = 2, ResourceName = "Software Analyst" });
                    resourceDetails.Add(new Resources() { ResourceID = 3, ResourceName = "Developer" });
                    resourceDetails.Add(new Resources() { ResourceID = 4, ResourceName = "Testing Engineer" });

                    return resourceDetails;
                }

            }
        }

        public class DefaultData
        {
            public string StartDate { get; set; }
            public string EndDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public int Duration { get; set; }
            public string PercentDone { get; set; }
            public List<object> ResourceID { get; set; }
            public List<DefaultData> Children { get; set; }
            public string Predescessor { get; set; }
        }
    }
}